#include "ti86asm.inc"
#include "asm86.h"
;
.org _asm_exec_ram
;
	nop								; pour le shell
	jp Depart
.dw $0000
.dw Title
Title:	.db "IR Remote control for PHILIPS",0
;
Depart:
	call _runindicoff
PHILIPS_TV:
	ld hl,$4FFF
	ld (cont),hl
	call _clrLCD					; efface l'cran
	ld a,1							; position de "TV" dans le menu
	call Affiche_Menu				; affiche le menu
	ld hl,PHILIPS_TV_Info			; charge tout le texte
	call Affiche_texte				; on l'affiche
PHILIPS_TV_b:
	call GETKEY
	cp K_EXIT
	jp z,Done
	ld hl,PHILIPS_TV_Key			; sinon on regarde si a correspond  1 touche mmorise
	ld bc,$0018						; nombre de touches fonctionnelles (24)
	cpir							; on cherche o elle est dans la chaine
	ld a,c							; rsultat dans bc
	jp nz,PHILIPS_TV_b				; pas trouv => on recommence
	ld hl,PHILIPS_TV_code
	add hl,bc
	ld a,(hl)
	ld (Cmde),a
	ld a,0							; Appareil 0(=tl)
	ld (App),a
	call Send_code					; on les envoie
	ld hl,$4FFF
	ld (cont),hl
	jr PHILIPS_TV_b					; on recommence
PHILIPS_VCR:
	ld hl,$4FFF
	ld (cont),hl
	call _clrLCD					; efface l'cran
	ld a,2							; position de "VCR" dans le menu
	call Affiche_Menu				; affiche le menu
	ld hl,PHILIPS_VCR_Info			; charge tout le texte
	call Affiche_texte				; on l'affiche
PHILIPS_VCR_b:
	call GETKEY
	cp K_EXIT
	jp z,Done
	ld hl,PHILIPS_VCR_Key			; sinon on regarde si a correspond  1 touche mmorise
	ld bc,$0014						; nombre de touches fonctionnelles
	cpir							; on cherche o elle est dans la chaine
	ld a,c							; rsultat dans bc
	jp nz,PHILIPS_VCR_b				; pas trouv => on recommence
	ld hl,PHILIPS_VCR_code
	add hl,bc
	ld a,(hl)
	ld (Cmde),a
	ld a,5							; Appareil 5(=VCR1)
	ld (App),a
	call Send_code						; on les envoie
	ld hl,$4FFF
	ld (cont),hl
	jr PHILIPS_VCR_b				; on recommence
PHILIPS_PreAmp:
	ld hl,$4FFF
	ld (cont),hl
	call _clrLCD					; efface l'cran
	ld a,3							; position de "P-Amp" dans le menu
	call Affiche_Menu				; affiche le menu
	ld hl,PHILIPS_PreAmp_Info		; charge tout le texte
	call Affiche_texte				; on l'affiche
PHILIPS_PreAmp_b:
	call GETKEY
	cp K_EXIT
	jp z,Done
	ld hl,PHILIPS_PreAmp_Key		; sinon on regarde si a correspond  1 touche mmorise
	ld bc,$000B						; nombre de touches fonctionnelles
	cpir							; on cherche o elle est dans la chaine
	ld a,c							; rsultat dans bc
	jp nz,PHILIPS_PreAmp_b			; pas trouv => on recommence
	ld hl,PHILIPS_PreAmp_code
	add hl,bc
	ld a,(hl)
	ld (Cmde),a
	ld a,16							; Appareil 16(=Pr-Amp)
	ld (App),a
	call Send_code						; on les envoie
	ld hl,$4FFF
	ld (cont),hl
	jr PHILIPS_PreAmp_b				; on recommence
PHILIPS_CD:
	ld hl,$4FFF
	ld (cont),hl
	call _clrLCD					; efface l'cran
	ld a,4							; position de "CD" dans le menu
	call Affiche_Menu				; affiche le menu
	ld hl,PHILIPS_CD_Info			; charge tout le texte
	call Affiche_texte				; on l'affiche
PHILIPS_CD_b:
	call GETKEY
	cp K_EXIT
	jp z,Done
	ld hl,PHILIPS_CD_Key			; sinon on regarde si a correspond  1 touche mmorise
	ld bc,$0010						; nombre de touches fonctionnelles
	cpir							; on cherche o elle est dans la chaine
	ld a,c							; rsultat dans bc
	jp nz,PHILIPS_CD_b				; pas trouv => on recommence
	ld hl,PHILIPS_CD_code
	add hl,bc
	ld a,(hl)
	ld (Cmde),a
	ld a,20							; Appareil 20(=CD)
	ld (App),a
	call Send_code						; on les envoie
	ld hl,$4FFF
	ld (cont),hl
	jr PHILIPS_CD_b					; on recommence
PHILIPS_Tuner:
	ld hl,$4FFF
	ld (cont),hl
	call _clrLCD					; efface l'cran
	ld a,5							; position de "Tuner" dans le menu
	call Affiche_Menu				; affiche le menu
	ld hl,PHILIPS_Tuner_Info		; charge tout le texte
	call Affiche_texte				; on l'affiche
PHILIPS_Tuner_b:
	call GETKEY
	cp K_EXIT
	jp z,Done
	ld hl,PHILIPS_Tuner_Key			; sinon on regarde si a correspond  1 touche mmorise
	ld bc,$000B						; nombre de touches fonctionnelles
	cpir							; on cherche o elle est dans la chaine
	ld a,c							; rsultat dans bc
	jp nz,PHILIPS_Tuner_b			; pas trouv => on recommence
	ld hl,PHILIPS_Tuner_code
	add hl,bc
	ld a,(hl)
	ld (Cmde),a
	ld a,17							; Appareil 17(=Tuner)
	ld (App),a
	call Send_code						; on les envoie
	ld hl,$4FFF
	ld (cont),hl
	jr PHILIPS_Tuner_b				; on recommence
Done:
	call _clrScrn					; on efface l'cran
	call _homeup					; curseur en haut
	ret								; on quitte le programme
;*******************************************************************************************
GETKEY:
	ld hl,(cont)
	dec hl
	ld (cont),hl
	ld a,h
	cp 0
	call z,ShutCalcOff
;
	ld a,$FD
	out (1),a
	in a,(1)
	bit 6,a
	jp z,Clear						; vite l'anti-rebond habituel des touches
	ld b,$FF						; clear et custom, sinon ce n'est pas trs
	ld a,$FD						; pratique pour commander le volume
	out (1),a
	in a,(1)
	bit 5,a
	jp z,Puiss
;
	call GET_KEY
	cp K_F1
	jp z,PHILIPS_TV
	cp K_F2
	jp z,PHILIPS_VCR
	cp K_F3
	jp z,PHILIPS_PreAmp
	cp K_F4
	jp z,PHILIPS_CD
	cp K_F5
	jp z,PHILIPS_Tuner
	ret
Clear:
	ld a,$0F
	jp Fin
Puiss:
	ld a,$0E
Fin:
	ld b,$FF
GKLoop1
	ld c,b
GKLoop2
	djnz GKLoop2
	ld b,c
	djnz GKLoop1
	ret
;*******************************************************************************************
;***************************** Routine pour afficher le "menu" *****************************
;*******************************************************************************************
Affiche_Menu:
	ld b,5							; 5 choix dans le menu
	ld de,$3A00						; position du menu
	ld hl,Menu						; charge le menu
AM_Loop:
	set 3,(iy+5)					; texte blanc sur noir
	dec a							; dcrmente a
	call z,Noir						; si a=0 le texte est noir sur blanc
	ld ($C37C),de					; coordonnees
	push af							; on sauve a
	call _vputs						; cette fonction dtruit a
	pop af							; on reprend a
	push hl							; on sauve le texte
	ld hl,$001A						; 26->l, 0->h
	add hl,de						; hl+de->hl
	ld e,l							; e->l, nouvelle abscisse
	pop hl							; on reprend le texte
	djnz AM_Loop					; on recommence
	res 3,(iy+5)					; texte noir sur blanc
	ret
Noir:
	res 3,(iy+5)					; texte noir sur blanc
	ret
;*******************************************************************************************
;*************** Routine pour afficher l'emplacement des touches mmorises ****************
;*******************************************************************************************
Affiche_texte:
	ld a,$1A						; cart entre 2 colonnes
	ld bc,$0905						; nombre de ligne(s)=9 - nombre de colonne(s)=5
	ld de,$0000						; 0->d, 0->e : coordonnes du 1er texte
Affiche_texte_Loop_1:
	push bc							; on sauve b 
	ld b,c							; c colonne par ligne
Affiche_texte_Loop_2:				; on affiche 1 ligne :
	ld ($C37C),de					; e->_penCol, d->_penRow
	push af
	call _vputs						; affiche 1 morceau
	pop af
	push hl							; sauvegarde du reste
	ld l,a
	add hl,de						; hl+de->hl
	ld e,l							; l->e, on a dcal d'1 colonne
	pop hl							; on reprend hl
	djnz Affiche_texte_Loop_2		; rpt b fois (=nbr de colonnes)
	pop bc							; on passe  la suivante
	push hl							; on sauve notre texte
	ld hl,$0600
	add hl,de
	ld e,0
	ld d,h							; on a dcal d'1 ligne
	pop hl							; on reprend hl
	djnz Affiche_texte_Loop_1		; rpt 9 fois (=nbr de lignes)
	ret
;*******************************************************************************************
;*************************** Routine pour teindre la calculette ***************************
;*******************************************************************************************
ShutCalcOff:
	ld a,1
	out (3),a                       ;w/o allowing them to take advantage
	halt                            ;of the holding down ENTER bug
	ld a,11
	out (3),a
	res 4,(IY+$09)
	ld hl,$4FFF
	ld (cont),hl
	ret
;*******************************************************************************************
;************ Routine pour convertir l'appareil et la commande en code RC5 *****************
;*******************************************************************************************
Send_code:
	ld a,(App)
	xor %11100000
	ld c,a
	call Change_4_bits
	ld (Code+4),a
	call Change_4_bits
	ld (Code+5),a
	ld a,(Cmde)
	cp 63
	call nz,Etendu
	ld c,a
	sla c
	sla c
	call Change_4_bits
	ld (Code+6),a
	call Change_4_bits
	xor %00001010
	ld (Code+7),a
;*******************************************************************************************
;****************** Routine pour envoyer le code par Sami Khawam ***************************
;*******************************************************************************************
SendData:
	ld a,$C0
	out (7),a					; sorties hautes
;
	ld a,(Code)					; Number of bytes
	ld b,a						; We load it into b for djnz
	call PutByte				; Send the Byte
	ld a,(Code+1)				; The Duration of a Bit
	call PutByte				; Send the Byte
	ld a,(Code+2)				; The First delay
	call PutByte				; Send the Byte
	ld a,(Code+3)				; The Second delay
	call PutByte				; Send the Byte
	ld hl,Code+4
NextByte:
	ld a,(hl)
	call PutByte				; Now we send all bytes.
	inc hl
	djnz NextByte
	ret
PutByte:
	push bc
	ld c,a
	ld b,8						; 8 Bits
PB_Next_Bit:
	ld a,$C0					; Set W1 and R1
	out (7),a
	rr c
	jr NC,PB_SendZero
	ld a,$E8
	jr PB_output_val
PB_SendZero:
	ld a,$D4
PB_output_val:
	out (7),a
	ld de,$FFFF					; For time-out
PB_Wait_for_W0_and_R0:
	in a,(7)
	and 3
	jr z,PB_Continue
	in a,(7)
	and 3
	jr z,PB_Continue
	dec de
	ld a,d
	or e
	jr NZ,PB_Wait_for_W0_and_R0
	jr PB_End					; If error return.
PB_Continue:
	ld a,$C0					; Set W1 and R1
	out (7),a
	ld de,$FFFF					; Reload time-out
PB_Wait_for_W1_and_R1:
	dec de
	ld a,d
	or e
	jr z,PB_End
	in a,(7)
	and 3
	cp 3
	jr NZ,PB_Wait_for_W1_and_R1
	djnz PB_Next_Bit
PB_End:
	pop bc
	ret
;*******************************************************************************************
Change_4_bits:
	xor a
	ld b,4
CtRC5:
	sla a
	sla a
	bit 7,c	
	jr nz,Un
	xor %00000010
	jr Suite
Un:
	xor %00000001
Suite:
	rlc c
	djnz CtRC5
	ret
;*******************************************************************************************
Etendu:
	ret c						; s'il est infreur  63, c'est fini
	sub 64						; sinon on lui retranche 64
	push af				; on sauve la nouvelle commande
	ld a,(Code+4)					; modification au niveau de l'adresse
	xor %00110000				; on change un 1 logique en 0
	ld (Code+4),a					; sauve cette modification
	pop af
	ret
;*******************************************************************************************
;*******************************************************************************************
Menu:
 .db " TV                ",0
 .db " VCR            ",0
 .db " P-Amp  ",0
 .db " CD                ",0
 .db " Tuner  ",0
cont:	.db 0,0
Code:	.db 4,32,$0E,$12,0,0,0,0
Cmde:	.db 0
App:	.db 0

;-------------------------------------------------------------------------------------------
PHILIPS_TV_Key:							; Il faut inverser les touches par rapport aux codes
 .db	K_STAR,K_UP,K_DOWN,K_LEFT,K_RIGHT,K_DEL,K_EE,K_SLASH
 .db	K_TAN,K_CUSTOM,K_RAISE,K_CLEAR,K_ALPHA,K_SECOND
 .db	K_9,K_8,K_7,K_6,K_5,K_4,K_3,K_2,K_1,K_0
PHILIPS_TV_code:
 .db	0,1,2,3,4,5,6,7,8,9,12,13,16,17,32,33,126,60,87,86,85,81,80,82
;
PHILIPS_VCR_Key:
 .db	K_LOG,K_TABLE,K_GRAPH
 .db	K_COS,K_SIN,K_PRGM,K_LN,K_TAN,K_CUSTOM
 .db	K_SECOND
 .db	K_9,K_8,K_7,K_6,K_5,K_4,K_3,K_2,K_1,K_0
PHILIPS_VCR_code:
 .db	0,1,2,3,4,5,6,7,8,9,12,32,31,45,48,50,52,53,54,55
;
PHILIPS_PreAmp_Key:
 .db	K_SECOND,K_9,K_8,K_7,K_6,K_5,K_4,K_3,K_2,K_1,K_0
PHILIPS_PreAmp_code:
 .db	0,1,2,3,4,5,6,7,8,9,12
;
PHILIPS_CD_Key:
 .db	K_TABLE,K_GRAPH
 .db	K_PRGM,K_LN
 .db	K_ALPHA
 .db	K_SECOND,K_9,K_8,K_7,K_6,K_5,K_4,K_3,K_2,K_1,K_0
PHILIPS_CD_code:
 .db	0,1,2,3,4,5,6,7,8,9,12,13,45,48,53,54
;
PHILIPS_Tuner_Key:
 .db	K_SECOND,K_9,K_8
 .db	K_7,K_6,K_5,K_4,K_3,K_2,K_1,K_0
PHILIPS_Tuner_code
 .db	0,1,2,3,4,5,6,7,8,9,12
;-------------------------------------------------------------------------------------------
PHILIPS_TV_Info:
 .db "Off",0,"QUIT",0,"",0,"",0,"",0
 .db "Mute",0,"",0,"OK",0,"",0,"",0
 .db "",0,"",0,"",0,"Prog +",0,"Vol +",0
 .db "",0,"",0,"",0,"Prog -",0,"Vol -",0
 .db "",0,"Text",0,"",0,"",0,"Formt",0
 .db "",0,"7",0,"8",0,"9",0,"Menu",0
 .db "",0,"4",0,"5",0,"6",0,"",0
 .db "",0,"1",0,"2",0,"3",0,"",0
 .db "",0,"0",0,"",0,"",0,"",0
PHILIPS_VCR_Info:
 .db "Off",0,"QUIT",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "Play",0,"Stop",0,"Pause",0,"Prog +",0,"",0
 .db "Rec",0," <<",0," >>",0,"Prog -",0,"",0
 .db "Eject",0,"",0,"",0,"",0,"",0
 .db "",0,"7",0,"8",0,"9",0,"",0
 .db "",0,"4",0,"5",0,"6",0,"",0
 .db "",0,"1",0,"2",0,"3",0,"",0
 .db "",0,"0",0,"",0,"",0,"",0
PHILIPS_PreAmp_Info:
 .db "Off",0,"QUIT",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"7",0,"8",0,"9",0,"",0
 .db "",0,"4",0,"5",0,"6",0,"",0
 .db "",0,"1",0,"2",0,"3",0,"",0
 .db "",0,"0",0,"",0,"",0,"",0
PHILIPS_CD_Info:
 .db "Off",0,"QUIT",0,"",0,"",0,"",0
 .db "Mute",0,"",0,"",0,"",0,"",0
 .db "Play",0,"Stop",0,"Pause",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "Eject",0,"",0,"",0,"",0,"",0
 .db "",0,"7",0,"8",0,"9",0,"",0
 .db "",0,"4",0,"5",0,"6",0,"",0
 .db "",0,"1",0,"2",0,"3",0,"",0
 .db "",0,"0",0,"",0,"",0,"",0
PHILIPS_Tuner_Info:
 .db "Off",0,"QUIT",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"",0,"",0,"",0,"",0
 .db "",0,"7",0,"8",0,"9",0,"",0
 .db "",0,"4",0,"5",0,"6",0,"",0
 .db "",0,"1",0,"2",0,"3",0,"",0
 .db "",0,"0",0,"",0,"",0,"",0
.end
